//Silencer v1.2 release 7-13-2000
//by [CF]antareus <antareus@starcraft.org>
//
//Industrial strength mute protection for industrial strength morons
//Faaaaaaaaaaaaaaaaaaast - developed on a P2 333 with V3 3000
//Tested only on my machine. Use at your own risk.
//
//Bugs, suggestions, et cetera to antareus@starcraft.org
//This is no programming wonder. Just a simple script to liberate your chathud.
//
//Requires Presto Pack 0.93+
//Requires latest NewOpts for autoloading
//Check my upcoming site at www.mattgreen.org
//
//In PrestoPrefs.cs I highly recommend you set $PrestoPref::Mute[all] = "repeat";
//
//Redistribute this script to the ends of the earth, provided you distribute the unmodified code complete with comments and readme.
//---------------------------------------------------
//
//Version history
//1.0 initial release. Mutes k-pack, some auto-response scripts
//1.1 better error messages, split mute definitions and preferences to separate file (not released)
//1.2 Some speed improvements
//		We now track flag events and mute messages that contain the flag carrier's name.
//		By default, all taunts are disabled. This goes a long way to eliminate clutter.
//		Option to mute all sounds relating to team damage (defaults to on. Faster than relying on built-in lists,
//		 but you no longer hear any messages with "Thanks," "Watch where you're shooting," or "Sorry").
//		Option to mute unnecessary server messages such as [CF]Antareus changed teams or [CF]Antareus is no longer on a team
//		New script specific mutes: all flag response scripts, writer's loadout announcements
//		K-Pack update: servers don't appear to honor a request for client muting via script. K-Pack users can still talk. I'm looking into this.
//
//---------------------CODE--------------------------


Include("Presto\\Mute.cs");
Include("Presto\\Events.cs");
Include("Presto\\Match.cs");

exec("antareus\\SilencerPrefs.cs");

$Silencer::Version="1.2";

if(! $Presto::version)
	echo("Cannot load Silencer " @ $Silencer::Version @ ": PrestoPack not loaded.");
else if($Presto::version < 0.93)
	echo("Cannot load Silencer " @ $Silencer::Version @ ": Your PrestoPack version (" @ $Presto::version @ ") is out of date.");
else if(! $PrestoPref::Mute)
	echo("Cannot load Silencer " @ $Silencer::Version @ ": Muting not enabled in PrestoPack.");

Event::Attach(eventExtendedClientMessage, Silencer::onExtendedClientMessage);
Event::Attach(eventClientDrop, Silencer::onClientDrop);

function Silencer::onExtendedClientMessage(%client, %msg, %text)	{
	if(%client != 0 && %client != getManagerId())	{
		//-----------------
		// CLIENT MESSAGES
		//-----------------
		if(String::FindSubStr(%msg, "~w")!=-1 && $Silencer::MutePacks)	{
			%snd=String::GetSubStr(%msg,String::FindSubStr(%msg,"~w")+2,Match::strLen(%msg)-1);
			if(! $Silencer::BaseSnd[%snd])	{
				echo("Muted(packs/disabled)- " @ Client::getName(%client) @ ": " @ %msg);
				return mute;
			}
		}
		else if(%text == "" || %text == " ")
			return mute;

		else if(Match::strLen(%msg) > 80)	{
			echo("Muted(length)- " @ %msg);
			return mute;
		}
		else if($Silencer::Temp::Msgs > 0)	{
			if($Silencer::Temp::Carrier["friendly"]!="")	{
				if(Client::getName(%client) == $Silencer::Temp::Carrier["friendly"])
					return mute;
				else if(String::FindSubStr(%msg, $Silencer::Temp::Carrier["friendly"])!=-1)
					return mute;
			}
			if($Silencer::Temp::Carrier["enemy"]!="")	{
				if(Client::getName(%client) == $Silencer::Temp::Carrier["enemy"])
					return mute;
				else if(String::FindSubStr(%msg, $Silencer::Temp::Carrier["enemy"])!=-1)
					return mute;
			}
		}
		for(%i=0; $Silencer::MuteList[%i]!=""; %i++)	{
			if(String::FindSubStr(%msg, $Silencer::MuteList[%i])!=-1)	{
				echo("Muted(list)- " @ Client::getName(%client) @ ": " @ %msg);
				return mute;
			}
		}
		for(%i=0; $Silencer::PermMuteList[%i]!=""; %i++)	{
			if(String::FindSubStr(%msg, $Silencer::PermMuteList[%i])!=-1)	{
				//doesn't seem to work
				remoteEval(2048, mute, 1, %client);
				getManagerId().muted[%client]=true;
				$Silencer::PermMutedClients[%client]=true;
				echo("Muted(permanent)- " @ Client::getName(%client) @ ": " @ %msg);
				return mute;
			}
		}
	}
	//-----------------
	// SERVER MESSAGES
	//-----------------
	else if(%client == 0 && $Silencer::MuteAutoMsgs)	{
		//
		//Flag taken
		//__________
		//-enemy or teammate takes flag
		if(Match::ParamString(%msg,"%p took the %t flag! ~wflag1.wav"))	{ //from Crunchy's ObjectiveTrak
			%carrier="";
			$Silencer::Temp::Msgs++;
			if($Silencer::MyTeamName == Match::Result(t))
				%carrier="enemy";
			else
				%carrier="friendly";

			$Silencer::BaseSnd["retflag"]=false;
			$Silencer::BaseSnd["flgtkm2"]=false;
			$Silencer::BaseSnd["haveflg"]=false;
			
			if(%carrier != "")	{
				$Silencer::Temp::Carrier[%carrier]=Match::Result(p);
				Schedule::Add("Silencer::ClearCarrier(\"" @ %carrier @ "\");", $Silencer::AutoMsgDelay);
			}
			return;
		}
		//-you take flag
		else if(Match::ParamString(%msg,"You took the %t flag! ~wflag1.wav"))	{
			$Silencer::Temp::Carrier["friendly"]=$PCFG::Name;
			Schedule::Add("Silencer::ClearCarrier(\"" @ %carrier @ "\");", $Silencer::AutoMsgDelay);
			return;
		}
		//
		//Flag returned
		//___________
		else if(String::FindSubStr(%msg, "Your flag was returned to base.")!=-1)	{
			$Silencer::BaseSnd["flaghm"]=false;
			Schedule::Add("$Silencer::BaseSnd[\"flaghm\"]=true;",$Silencer::AutoMsgDelay);
			return;
		}
		//
		//Switching teams
		//___________
		else if(Match::ParamString(%msg, $PCFG::Name @ " joined team %t."))	{
			$Silencer::MyTeamName=Match::Result(t);
			return;
		}
		else {
			for(%i=0; $Silencer::ServerMuteList[%i]!=""; %i++)	{
				if(String::FindSubStr(%msg, $Silencer::ServerMuteList[%i])!=-1)	{
					echo("Muted(server)- " @ %msg);
					return mute;
				}
			}
		}
	}
} //Silencer::onExtendedClientMessage

function Silencer::onClientDrop(%client)	{
	if($Silencer::PermMutedClients[%client])	{
		$Silencer::PermMutedClients[%client]="";
		getManagerId().muted[%client]=false;
		remoteEval(2048, mute, 0, %client);
	}
}

function Silencer::ClearCarrier(%carrier)	{
	$Silencer::Temp::Carrier[%carrier]="";
	$Silencer::Temp::Msgs--;
	$Silencer::BaseSnd["retflag"]=true;
	$Silencer::BaseSnd["haveflg"]=true;
	$Silencer::BaseSnd["flgtkm2"]=true;
}

if($Silencer::TDMutes)	{
	$Silencer::BaseSnd["wshoot3"]=false;
	$Silencer::BaseSnd["wshoot1"]=false;
	$Silencer::BaseSnd["sorry"]=false;
}

if($Silencer::MuteTaunts)	{
	$Silencer::BaseSnd["cheer1"]=false;
	$Silencer::BaseSnd["cheer2"]=false;
	$Silencer::BaseSnd["cheer3"]=false;
	$Silencer::BaseSnd["color2"]=false;
	$Silencer::BaseSnd["color3"]=false;
	$Silencer::BaseSnd["color6"]=false;
	$Silencer::BaseSnd["color7"]=false;
	$Silencer::BaseSnd["dsgst1"]=false;
	$Silencer::BaseSnd["dsgst2"]=false;
	$Silencer::BaseSnd["dsgst4"]=false;
	$Silencer::BaseSnd["dsgst5"]=false;
	$Silencer::BaseSnd["ovrhere"]=false;
	$Silencer::BaseSnd["taunt1"]=false;
	$Silencer::BaseSnd["taunt10"]=false;
	$Silencer::BaseSnd["taunt2"]=false;
	$Silencer::BaseSnd["taunt3"]=false;
	$Silencer::BaseSnd["taunt4"]=false;
	$Silencer::BaseSnd["tautn11"]=false;
}

echo("Silencer " @ $Silencer::Version @ " loaded.");
	
